> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt.

# प्रोसीजर ड्राफ़्ट अपडेट करें

PATCH https://api.elevenlabs.io/v1/convai/agents/{agent_id}/branches/{branch_id}/procedures/{procedure_id}/draft
Content-Type: application/json

किसी प्रक्रिया के लिए यूज़र का ड्राफ़्ट बनाएं या अपडेट करें

Reference: https://elevenlabs.io/docs/api-reference/agents/procedures/update

## Servers

- `https://api.elevenlabs.io` (Production, default)
- `https://api.us.elevenlabs.io` (Production US)
- `https://api.eu.residency.elevenlabs.io` (Production EU)
- `https://api.in.residency.elevenlabs.io` (Production India)
- `https://api.sg.residency.elevenlabs.io` (Production Singapore)

## Request

### Path parameters

- `agent_id` (string, required) — प्रक्रिया ड्राफ़्ट पाने के लिए एजेंट ID
- `branch_id` (string, required) — प्रोसीजर ड्राफ़्ट पाने के लिए Branch ID
- `procedure_id` (string, required) — प्रक्रिया ID

### Body (application/json)

This endpoint expects an UpdateProcedureDraftRequestModel.

- `name` (string, required) — Procedure नाम
- `content` (string, required) — Procedure content
- `type` (enum, required, default: free_form) — Procedure प्रकार
  - Allowed values: `free_form`, `deterministic`, `folder`
- `trigger` (string, optional, nullable) — एजेंट को यह प्रक्रिया कब इस्तेमाल करनी चाहिए। खाली स्ट्रिंग का मतलब है कि यह एक उप-प्रक्रिया है, जो केवल तभी शुरू होनी चाहिए जब कोई दूसरी प्रक्रिया इसे रेफ़र करे। सेव किए गए ट्रिगर को बनाए रखने के लिए इस फ़ील्ड को छोड़ दें (या null भेजें), जो बनाते समय खाली होता है। इसे हटाने के लिए `""` भेजें। `description` को उपनाम के रूप में स्वीकार किया जाता है।

## Response

### 200

सफल रिस्पॉन्स

- `procedure_id` (string, required) — Procedure ID
- `name` (string, required) — Procedure नाम
- `content` (string, required) — Procedure content
- `type` (enum, optional, default: free_form) — Procedure प्रकार
  - Allowed values: `free_form`, `deterministic`, `folder`
- `trigger` (string, optional, default: ) — एजेंट को इस प्रक्रिया का उपयोग कब करना चाहिए। खाली स्ट्रिंग का मतलब है कि यह एक उप-प्रक्रिया है, जो केवल तब शुरू होनी चाहिए जब कोई दूसरी प्रक्रिया इसका संदर्भ दे।
- `folder_parent_id` (string, optional, nullable) — उस folder की Procedure ID जिसमें यह procedure रखा गया है। None का अर्थ root है।

## Errors

### 422 Unprocessable Entity Error

वैलिडेशन एरर

- `detail` (list of ValidationError, optional)

## Types

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### ValidationErrorLocItems

## Examples

**Request**

```json
{
  "name": "string",
  "content": "string",
  "type": "free_form"
}
```

**Response**

```json
{
  "procedure_id": "agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3",
  "name": "Customer Support Procedure",
  "content": "# Customer Support Procedure\n\n1. Greet the customer...",
  "type": "free_form",
  "trigger": "When the customer asks for support"
}
```

**SDK Code**

```python
import requests

url = "https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft"

payload = {
    "name": "string",
    "content": "string",
    "type": "free_form"
}
headers = {"Content-Type": "application/json"}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft';
const options = {
  method: 'PATCH',
  headers: {'Content-Type': 'application/json'},
  body: '{"name":"string","content":"string","type":"free_form"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft"

	payload := strings.NewReader("{\n  \"name\": \"string\",\n  \"content\": \"string\",\n  \"type\": \"free_form\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"string\",\n  \"content\": \"string\",\n  \"type\": \"free_form\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"string\",\n  \"content\": \"string\",\n  \"type\": \"free_form\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft', [
  'body' => '{
  "name": "string",
  "content": "string",
  "type": "free_form"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"string\",\n  \"content\": \"string\",\n  \"type\": \"free_form\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [
  "name": "string",
  "content": "string",
  "type": "free_form"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/convai/agents/agent_3701k3ttaq12ewp8b7qv5rfyszkz/branches/agtbranch_0901k4aafjxxfxt93gd841r7tv5t/procedures/agtprc_6qbpwdq8n01bxhk44bgjy6f10ck3/draft")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```